


/*
 Horloge mère avec CI DS3232 et Afficheur 64*128  (Version 2.1)
 
 ATTENTION: chaque bouton envoie une tension différente sur Pin A0
 Cette valeur est à modifier selon les résistances utilisées. 
 Pour cela mesurer chaque tension PIN A0 lors de l'appuie sur un bouton
 puis après le calcul suivant: ((1023/5) x tension)/100 reporter
 le résultat après les 3 mots "case" au chapitre "Sélection réglage" 
 qui correspondent  chacun à un des boutons. 
 
 Mon site http://f5mna .free.fr

 Juillet 2014   
 Octobre 2015   Ajout jours semaine.
 Novembre 2015  Bug jous < 10.
 Mars 2017      Tension alternee.
*/

#include <U8glib.h> 
#include <Wire.h>
#include <math.h>
#include <DS1307new.h>

//U8GLIB_ST7920_128X64_4X u8g(2, 10, 7);     // Pour  avec platine série 
U8GLIB_ST7920_128X64_1X u8g(6, 5, 4 ,7); // Pour ST7920 128*64 sans platine additive

//Horloge
int angles,anglem,angleh,xs, ys, xm, ym, xh, yh;
float rad;

//DS3232
//////////////////////////////////////////////////
int I2C_DS3232=0xD0 >> 1;
byte DS3232control=0b00011100, DS3232status=0b11001000 ,DS3232aging ,DS3232Msb ,DS3232Lsb;
//////////////////////////////////////////////////
uint16_t startAddr = 0x0000;       // Adresse de démarrage Start dans  NV-RAM
uint16_t lastAddr;                 // Nelle addresse des stockage NV-RAM
uint16_t TimeIsSet = 0xaa55;       // Prévient qu'il n'y a pas de remise à l'heure
//
/*
CI DS3232
VDD  3VCC ou 5VCC  
SDA  A4
SCL  A5
*/

#define Touche_PIN  A0 // Entree platine Boutons
int sensorPin = A0;  
int sensorValue = 0; 
int val_key;
int Select;
int Heure;
int Minute;
int Seconde;
int Jour;
int Mois;
int Annee;
int JourSem;
 
/*///////////////////////
 const uint8_t rook_bitmap[] PROGMEM = { // Symbole degre.
  0x10,         // 00010000 
  0x28,         // 00101000
  0x28,         // 00101000
  0x10,         // 00010000
  0x00,         // 00000000 
  0x00,         // 00000000
  0x00,         // 00000000 
  0x00          // 00000000
};  
*/ 
//////////////////////////
////// Sorties tensions alternées + avance rapide //////
int Altern1 = 11; // pin 11 tension alternée 
int Altern2 = 12; // pin 12 tension alternée inverse

void setup () {
  
  pinMode(2, INPUT);                    // Test  SQW pin, D2 = INPUT
  digitalWrite(2, HIGH);                // Test  SQW pin, D2 = Pullup on
 
  RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entree startAddr in NV-RAM address 0x08 
  TimeIsSet = 0xffff;
  RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));  
  RTC.ctrl = 0x00;     // 0x00=disable SQW pin, 0x10=1Hz,
                       // 0x11=4096Hz, 0x12=8192Hz, 0x13=32768Hz
  RTC.setCTRL();

    pinMode( Touche_PIN, INPUT );         //ensure A0 is an input
    digitalWrite( Touche_PIN, LOW );      //ensure pullup is off on A0
    
    ////// Déclaration tension alternée & Avance rapide//////////
    pinMode(Altern1, OUTPUT);
    pinMode(Altern2, OUTPUT);
    
       u8g.setFont(u8g_font_6x12); //Font Afficheur
    // u8g.setFont(u8g_font_fur14); //Font Afficheur   
    
  rad = ((2 * 3.1415926536) / 360);
}
////////////////////////////

 void Principal()
 {
  sensorValue = analogRead(sensorPin); // lecture de la touche
  val_key = int(sensorValue/100);      // valeur entière de la touche / 10

 /// Affichage marche////
 if  (Select == 0)  
 {  
 RTC.getTime();
 Heure = RTC.hour;
 Minute = RTC.minute;
 Seconde = RTC.second;
 Jour = RTC.day;
 Mois = RTC.month;
 Annee = RTC.year; 
 //JourSem  = RTC.dow; 

  //////// TENSION ALTERNEE /////////////     

  if (RTC.second == 0) {
  digitalWrite(Altern1, HIGH);
  digitalWrite(Altern2, LOW);}

  else if (RTC.second == 30) {
  digitalWrite(Altern1, LOW);
  digitalWrite(Altern2, HIGH);}

  else {
   digitalWrite(Altern1, HIGH);    //////////Selon résistances de tirage (au + VCC pour L9110)
   digitalWrite(Altern2, HIGH);}   //////////Selon résistances de tirage (au + VCC pour L9110)
 
  //FONT
  u8g.setFont(u8g_font_timB14);
 
  if (Heure < 10){   u8g.drawStr( 60, 26, "0");
  u8g.setPrintPos(69,26); //Heure
  u8g.print(Heure);}
  else
  {u8g.setPrintPos(61,25); //Heure
  u8g.print(Heure);}
  
  u8g.drawStr( 78,25, ":");
  
  if (Minute < 10){ u8g.drawStr( 84, 25, "0");
  u8g.setPrintPos( 94, 25);//Minute
  u8g.print(Minute);}
  else
  {u8g.setPrintPos( 85, 25);//Minute
  u8g.print(Minute);}  
  
  u8g.drawStr( 102, 25, ":");
  
  if (Seconde < 10){ u8g.drawStr( 108, 25, "0");
  u8g.setPrintPos( 117, 25);//Seconde
  u8g.print(Seconde);}
  else
  {u8g.setPrintPos(108, 25);//Seconde
  u8g.print(Seconde);} 
  
  
  u8g.setFont(u8g_font_5x7); //Font Afficheur

//////////////////////////////////////////////////////////////////////////////
 switch (RTC.dow)                      
  {
    case 1:
      u8g.drawStr( 73, 47," Lundi  ");
      break;
    case 2:
      u8g.drawStr( 73, 47," Mardi  ");
      break;
    case 3:
      u8g.drawStr( 73, 47,"Mercredi");
      break;
    case 4:
      u8g.drawStr( 73, 47," Jeudi  ");
      break;
    case 5:
      u8g.drawStr( 73, 47,"Vendredi");
      break;
    case 6:
      u8g.drawStr( 73, 47," Samedi ");
      break;
    case 0:
      u8g.drawStr( 73, 47,"Dimanche");
      break;
  }

 //////////////////////////////////////////////////////
  if (Jour < 10) { u8g.drawStr( 57, 57, "0");
  u8g.setPrintPos(62,57); //Jour
  u8g.print(Jour);}
    else
  {u8g.setPrintPos(57,57); //Jour
  u8g.print(Jour);}
 
    switch (RTC.month){
    case 1:
         u8g.drawStr( 70, 57, "Janvier");
     break;
    case 2:
         u8g.drawStr( 70, 57, "fevrier");
    break;
    case 3:
        u8g.drawStr( 70, 57, "  mars");
    break;
     case 4:
        u8g.drawStr( 70, 57, " avril ");
    break;
     case 5:
        u8g.drawStr( 70, 57, "  mai  ");
    break;
     case 6:
        u8g.drawStr( 70, 57, " juin  ");
    break;
    case 7:
        u8g.drawStr( 70, 57, "Juillet");
    break;
     case 8:
        u8g.drawStr( 69, 57, "  aout  ");
    break;
     case 9:
        u8g.drawStr( 70, 57, " septe.");
    break;
     case 10:
        u8g.drawStr( 69, 57, "octobre");
    break;
     case 11:
        u8g.drawStr( 70, 57, "novemb.");
    break;
     case 12:
        u8g.drawStr( 70, 57, "decemb.");
    break;
    }
  u8g.setPrintPos(106,57); //Année
  u8g.print(Annee);
 
/*  ///////////////////
  ////Temperature////   
  ///////////////////
      delay(100);                                     
       Wire.beginTransmission(I2C_DS3232);             
       Wire.write(0x0F);                               
       Wire.endTransmission();                         
       Wire.requestFrom(I2C_DS3232, 1);                
       DS3232status=Wire.read();                       
       if (( DS3232status & 0b00000100)== 0b00000000)  
              {delay(100);                             
               Wire.beginTransmission(I2C_DS3232);     
               Wire.write(0x11);                       
               Wire.endTransmission();                 
               Wire.requestFrom(I2C_DS3232, 2);       
               DS3232Msb=Wire.read();                   
               DS3232Lsb=Wire.read();                    
              }  
  ///// Affichage Temperature ////
  u8g.setPrintPos( 84, 35);
  u8g.print(DS3232Msb, DEC);
  u8g.drawBitmapP( 93, 29, 1, 8, rook_bitmap);
  u8g.drawStr( 99, 35,"C"); 
*/
   ///////////////////////////////////////////////////////////////////////////
   //Avance rapide pour remise à d'une horloge exterieure (tension alternée)
   //////////////////////////////////////////////////////////////////////////
    if (val_key == 0)
     {
       digitalWrite (Altern1, HIGH);
       digitalWrite (Altern2, LOW);
         delay(250);
       digitalWrite (Altern1, LOW);
       digitalWrite (Altern2, HIGH);
       delay(250);         
     } 
  }
  ///////////////////////////////
  //Dessin horloge - Aiguilles///
  ///////////////////////////////
  angles = (Seconde * 6)-90;  
  anglem = (Minute * 6)-90;  
  angleh = ((Heure * 30)-90) + ((anglem/12)+6);
  Serial.println (angleh);
  
  u8g.drawCircle(31,32,21);
  u8g.drawCircle(31,32,19);
   
  u8g.setFont(u8g_font_micro);
  u8g.drawStr( 56, 35, "3");
  u8g.drawStr( 30, 60, "6");
  u8g.drawStr( 3, 35, "9");
  u8g.drawStr( 28, 10, "12");
  
  u8g.drawStr( 40, 16, "."); //1
  u8g.drawStr( 47, 24, "."); //2
  u8g.drawStr( 50, 33, "."); //3
  u8g.drawStr( 47, 42, ".");  //4
  u8g.drawStr( 41, 50, ".");  //5
  u8g.drawStr( 31, 53, ".");  //6
  u8g.drawStr( 21, 50, ".");  //7
  u8g.drawStr( 14, 42, ".");  //8
  u8g.drawStr( 11, 33, ".");  //9
  u8g.drawStr( 14, 24, ".");  //10
  u8g.drawStr( 21, 16, ".");  //11
  u8g.drawStr( 31, 14, "."); //12

  xs = 31 + (cos(angles * rad)*18);
  ys = 32 + (sin(angles * rad)*18);
  u8g.drawLine(31, 32, xs, ys);

   
   xm = 31 + (cos(anglem * rad)*16);
   ym = 32 + (sin(anglem * rad)*16); 
   u8g.drawLine(31, 32, xm, ym);
   u8g.drawLine(32, 31, xm, ym);
    
     
   xh = 31 + (cos(angleh * rad)*10);
   yh = 32 + (sin(angleh * rad)*10); 
   u8g.drawLine(31, 32, xh, yh);
   u8g.drawLine(32, 31, xh, yh);
 

///////////////////////////////////////////////////////////////////////////////////////////
//                                  R E G L A G E                                        //
///////////////////////////////////////////////////////////////////////////////////////////
  
  
  if ((Select > 0) and (Select < 8))
  { 
  u8g.drawStr(80,18,"REGLAGES"); 
    
  if (Jour < 10)  { u8g.drawStr( 73, 30, "0");
  u8g.setPrintPos(77,30); //Jour
  u8g.print(Jour);}
  else
  {u8g.setPrintPos(73,30); //jour
  u8g.print(Jour);}
  
  u8g.drawStr( 83,30, ":");  

  if (Mois < 10) {  u8g.drawStr( 89, 30, "0");
  u8g.setPrintPos( 94, 30);//Mois
  u8g.print(Mois);}
    else
  {u8g.setPrintPos(89,30); //Mois
  u8g.print(Mois);}
  
  u8g.drawStr( 100, 30, ":");
  
  u8g.setPrintPos( 105, 30);//Annee
  u8g.print(Annee); 
 
  if (Heure < 10){   u8g.drawStr( 78, 40, "0");
  u8g.setPrintPos(82,40); //Heure
  u8g.print(Heure);}
  else
  {u8g.setPrintPos(78,40); //Heure
  u8g.print(Heure);}
  
  u8g.drawStr( 88,40, ":");
  
  if (Minute < 10){   u8g.drawStr(93, 40, "0");
  u8g.setPrintPos( 98, 40);//Minute
  u8g.print(Minute);}
  else
  {u8g.setPrintPos( 93, 40);//Minute
  u8g.print(Minute);}  
  
  u8g.drawStr( 105, 40, ":");
  
  if (Seconde < 10){   u8g.drawStr(110, 40, "0");
  u8g.setPrintPos( 115, 40);//Seconde
  u8g.print(Seconde);}
  else
  {u8g.setPrintPos( 110, 40);//Seconde
  u8g.print(Seconde);}  
  }

  val_key = 0;                           // RAZ valeur de la touche 
  sensorValue = analogRead(sensorPin);   // lecture de la touche
  val_key = int(sensorValue/100);         // valeur entière de la touche / 10
 
////////////////////////////////////////////////////////
/////////// Selection des reglages /////////////////////
////////////////////////////////////////////////////////

   switch (val_key) 
       {
          case 0 : //Select  ///////////////////////////////////////////////////////////////////
       { 
         Select = (Select + 1);
         delay (200);
        }
         break;
       }      

        if (Select == 1) u8g.drawStr(70,50," Reglage jour");
     
        if (Select == 2) u8g.drawStr(70,50," Reglage mois");
 
        if (Select == 3) u8g.drawStr(65,50," Reglage annee");
   
        if (Select == 4) u8g.drawStr(70,50,"Reglage heures");
    
        if (Select == 5) u8g.drawStr(70,50,"Reglage minutes");
        
        if (Select == 6) u8g.drawStr(65,50,"Reglage Secondes"); 
  
        if (Select == 7) u8g.drawStr(90
        
        ,50, "TOP !");
  
        if (Select == 8){
           (Select = 0);
            RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entrée startAddr dans NV-RAM address 0x08 
            TimeIsSet = 0xffff;
            RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));         
            if (TimeIsSet != 0xaa55)
            {
             RTC.stopClock();        
             RTC.fillByYMD(Annee,Mois,Jour);
             RTC.fillByHMS(Heure,Minute,Seconde);
    
             RTC.setTime();
             TimeIsSet = 0xaa55;
             RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
             RTC.startClock();
            }
            else
            {
             RTC.getTime();
            }       
       }
            
  switch (val_key) 
  
       {   
   case 3: //Down    /// (1023/5)x 1.54 = 315  //////////////////////////////////////////////////////////////
        {    
        delay (200);     
        if (Select == 1) {Jour = (Jour - 1);}  
        if (Jour < 1) {(Jour = 31);}
        if (Select == 2){ Mois = (Mois - 1);}
        if (Mois < 1) {(Mois = 12);} 
        if (Select == 3){Annee = (Annee - 1);}
       
        if (Select == 4) {Heure = (Heure - 1);}  
        if (Heure < 1) {(Heure = 23);}
        if (Select == 5){ Minute = (Minute - 1);}
        if (Minute < 1) {(Minute = 59);} 
        if (Select == 6){Seconde = (Seconde - 1);}
        if (Seconde < 1) {(Seconde = 59);}
        }
        break;
        
  case 4: //UP      ////(1023/5) x 2.334 = 478 ////////////////////////////////////////////////////////////////////
        { 
         delay (200);
        if (Select == 1) {Jour = (Jour + 1);}  
        if (Jour > 31) {(Jour = 1);}
        if (Select == 2){ Mois = (Mois + 1);}
        if (Mois > 12) {(Mois = 1);} 
        if (Select == 3){Annee = (Annee + 1);}
       
        if (Select == 4) {Heure = (Heure + 1);}  
        if (Heure > 23) {(Heure = 0);}
        if (Select == 5){ Minute = (Minute + 1);}
        if (Minute > 59 ) {(Minute = 0);} 
        if (Select == 6){Seconde = (Seconde + 1);}
        if (Seconde > 59) {(Seconde = 0);}
        }
        break;
   }
 }
  
 void loop() 
 { 
   u8g.firstPage();  
   do 
   Principal(); 
   while( u8g.nextPage());

  
 }

